; > monc64.asm
;
; Include for for EhBasic for C64 target
; J.G.Harston 10-Oct-2016
;
; This can be built with cc65 with:
; cl65 -t none -l --feature labels_without_colons -o ehbasic.bin monc64.asm 2> ehbasic.log


.include "ver.asm"
.define	 TARGET	C64

BREAK    =$1B		; Code of keypress to interrupt program
MEMBOT   =$0900		; Bottom of memory
MEMTOP   =$A000		; Top of memory, ask the user to confirm
ZPSTART  =$00		; Start of zero page workspace
ZPWARM   =$02		; 6510 has I/O in locations 00/01
ZPEND    =$8F		; End of zero page workspace
ZPROUT   =0		; No subroutines in zero page
WSSTART  =$0800		; Start of vector and input buffer workspace
CODESTART=$A000		; Start of program code

.ORG	CODESTART
	.word C64COLD
	.word C64WARM
	.byte "CBM80"
	.byte "EhBASIC"
	.byte 0
	.byte VERSION
	.byte 0

C64COLD
C64WARM
	LDX	#$FF
	TXS			; Clear stack
	CLD			; Ensure binary mode
	CLI			; Ensure interupts enabled


.INCLUDE "ehbasic.asm"		; ** INCLUDE MAIN BASIC CODE **


MON_INIT
	LDX	#VECEND-VECSTART
HOSTLP1
	LDA	VECSTART,X	; Set up vectors
	STA	VEC_CC,X
	DEX
	BPL	HOSTLP1
	RTS
VECSTART
	.word	C64ESCCHK
	.word	C64RDCH
	.word	$FFD2		; C64WRCH
	.word	C64LOAD
	.word	C64SAVE
	.word	C64RTS
VECEND

; Check for program interupt
C64ESCCHK
	JSR	$FFE1		; Test for STOP key
	BNE	C64RTS		; STOP not pressed
	LDA	#BREAK
	JMP	LAB_1636	; Jump to BREAK handler

; Check for keypress
C64RDCH
	JSR	$FFCF
	CMP	#$01		; CC=No key, CS=key pressed
C64RTS	RTS

;; Output a character
;C64WRCH
;	JMP	$FFD2

; LOAD and SAVE
C64LOAD
	LDA	#$FF		; $FF=load
	JSR	C64FILE
	LDA	#<LAB_RMSG	; "READY"
	LDY	#>LAB_RMSG
	JSR	LAB_18C3
	JMP	LAB_1319	; relink program and clear variables
C64SAVE
	LDA	#$00		; $00=save
C64FILE
	PHA			; save operation
	JSR	LAB_EVEX
	JSR	LAB_EVST	; evaluate string
;... unimplemented
	PLA
	RTS
